package service

const (
	ErrOk                 = 0
	ErrNeedParam          = 1
	ErrParamRange         = 14
	ErrCompany            = 1000
	ErrAllocateFail       = 1001
	ErrCompanyParam       = 1002
	ErrRouteTag           = 1003
	ErrNeedUid            = 1004
	ErrSuitRote           = 1005
	ErrTGid               = 1006
	ErrInParam            = 1007
	ErrQueryError         = 1008
	ErrCustomerNotFind    = 2001
	ErrCustomerNotOnline  = 2002
	ErrCustomerQueue      = 2004
	ErrQueueEmpty         = 2005
	ErrPhone              = 1010003
	ErrPhoneExist         = 4
	ErrAddDataFail        = 1010005
	ErrMaxReceiveNum      = 2006
	ErrBlackList          = 2007
	ErrAddFail            = 2008
	ErrUpdateFail         = 2009
	ErrEmptyDataError     = 2010
	ErrMaxReceiveNumLimit = 2011
	ErrMaxRecoveryNum     = 2012
	ErrNameLen            = 1010004
	ErrNeedLen            = 1010006
	ErrGroupNotFind       = 3001
	ErrGroupOnline        = 3002
	ErrParamError         = 28
	ErrParamCheck         = 5001
	ErrTokenCheck         = 20001
	ErrUserNotFind        = 5003
	ErrServer             = 5004
	ErrExist              = 5005
	ErrNotExist           = 5006
	ErrTokenExpired       = 20002
	Err                   = 20003
	ErrDataTooLong        = 1406
	ErrData               = 2
	ErrAllocation         = 20013
	ErrProp               = 20014
	ErrTopicInfo          = 20015

	ERROR_SIGN_FAIL       = 30001
)

var errCodeMap = map[int]string{
	ErrDataTooLong:        "数据长度超过存储限制",
	ErrOk:                 "请求成功",
	ErrNeedParam:          "缺少参数！",
	ErrParamRange:         "参数范围错误",
	ErrNeedUid:            "缺少uid",
	ErrCompany:            "获取公司路由分组错误",
	ErrCompanyParam:       "公司参数错误",
	ErrSuitRote:           "没有符合条件的路由",
	ErrPhoneExist:         "手机号已经存在",
	ErrAddDataFail:        "数据添加失败",
	ErrTGid:               "错误的技能组id",
	ErrNameLen:            "输入姓名不能大于12字符！",
	ErrNeedLen:            "输入内容不能大于500个字符",
	ErrRouteTag:           "标签参数错误",
	ErrInParam:            "参数错误",
	ErrAllocateFail:       "分配失败或者对应客服不在线", //客服不在线
	ErrCustomerNotFind:    "客服不存在",
	ErrCustomerQueue:      "排队中，请稍等",
	ErrMaxReceiveNum:      "会话数达到最大接待数上线",
	ErrBlackList:          "黑名单用户",
	ErrQueueEmpty:         "当前没有用户在排队",
	ErrCustomerNotOnline:  "顾问不在线",
	ErrGroupNotFind:       "找不到符合条件的技能组",
	ErrGroupOnline:        "技能组没有在线客服",
	ErrAddFail:            "添加失败",
	ErrUpdateFail:         "更新失败",
	ErrQueryError:         "数据库查询失败",
	ErrEmptyDataError:     "空记录",
	ErrMaxReceiveNumLimit: "最大接待数设置上线为100",
	ErrMaxRecoveryNum:     "快捷回复字数不能超过500字",
	ErrParamCheck:         "参数不合法",
	ErrTokenCheck:         "Token鉴权失败",
	ErrUserNotFind:        "用户不存在",
	ErrServer:             "服务端处理错误",
	ErrExist:              "数据已存在",
	ErrNotExist:           "数据不存在",
	ErrParamError:         "参数错误",
	ErrTokenExpired:       "Token已过期",
	ErrData:               "暂无数据",
	Err:                   "服务器错误",
	ErrAllocation:         "分配失败",
	ErrPhone:              "电话号码错误",
	ErrProp:               "国家和公司找不到对应标签",
	ERROR_SIGN_FAIL:       "签名错误",
	ErrTopicInfo:		   "会话信息错误",
}
type SerError int

func (e SerError) String() string {
	if v, er := errCodeMap[int(e)]; er {
		return v
	}
	return "未找到错误码，请检查错误码"
}
